unit Unit1;

interface
{$DEFINE USE_WINDOWS_API}
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls;

type
  TForm1 = class(TForm)
    Label1: TLabel;
    Memo1: TMemo;
    procedure FormCreate(Sender: TObject);
  private
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

uses
{$IFDEF USE_WINDOWS_API}
 ActiveX,ComObj,
{$ELSE}
 POIFS,
{$ENDIF}
 XL8;

type
 TChunk=packed record
  Tag :word;
  Size:word;
 end;

 TBIFFStream=class(TMemoryStream)
  Chunk:TChunk;
  function GetChunk:word;
  procedure Parse(Log:TStrings);
 end;

function TBIFFStream.GetChunk:word;
begin
 ReadBuffer(Chunk,SizeOf(Chunk));
 Result:=Chunk.Tag;
end;

procedure TBIFFStream.Parse(Log:TStrings);
var
 SST:TBIFF8_SST;
 len:packed record
  size:word;
  flag:byte;
 end;
 i:integer;
 s:string;
 ws:WideString;
begin
 Position:=0;
// pour chaque groupe donnes (infos globales, Feuil1, Feuil2...)
 while GetChunk=BIFF8_BOF do begin
  repeat
  // Est-ce une Shared String Table ?
   if Chunk.Tag=BIFF8_SST then begin
   // Alors lire les chaines qu'elle contient
    ReadBuffer(SST,SizeOf(SST));
    for i:=0 to SST.Count-1 do begin
     ReadBuffer(Len,SizeOf(Len));
     if len.flag=1 then begin
      SetLength(ws,Len.size);
      ReadBuffer(ws[1],2*Len.Size);
      s:=ws;
      ws:='';
     end else begin
      SetLength(s,Len.Size);
      ReadBuffer(s[1],Len.Size);
     end;
     Log.Add(s);
    end;
   end else begin
   // Sinon, ignorer le Chunk
    Seek(Chunk.Size,soFromCurrent);
   end;
  // jusqu'au marquer de fin de donnes
  until GetChunk=BIFF8_EOF;
 end;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
{$IFDEF USE_WINDOWS_API}
 STG :IStorage;
 STM :IStream;
 Size:int64;
{$ELSE}
 FS:TPOIFS;
{$ENDIF}
 Stream:TBIFFStream;
begin
 Memo1.Text:='Lecture de Classeur1.xls ...';
 Stream:=TBIFFStream.Create;
 try
 {$IFDEF USE_WINDOWS_API}

 // ouverture du classeur Excel via OLE2

  OleCheck(StgOpenStorage('Classeur1.xls', nil, STGM_DIRECT or STGM_SHARE_EXCLUSIVE or STGM_READ, nil, 0, STG));
  OleCheck(STG.OpenStream('Workbook',nil, STGM_DIRECT or STGM_SHARE_EXCLUSIVE or STGM_READ,0,STM));
  OleCheck(STM.Seek(0,STREAM_SEEK_END,Size));
  Stream.Size:=Size;
  OleCheck(STM.Seek(0,STREAM_SEEK_SET,Size));
  OleCheck(STM.Read(Stream.Memory,Stream.Size,nil));

 {$ELSE}

 // ouverture du classeur Excel via POIFS

  FS:=TPOIFS.Create;
  try
   FS.OpenFile('Classeur1.xls');
   FS.GetStream('Workbook',Stream);
  // Bonus: cration d'un nouveau classeur compatible mais beaucoup plus petit :D
   FS.CreateFile('Classeur2.xls');
   FS.AddStream('Workbook',Stream,True);
  finally
   FS.Free;
  end;
 {$ENDIF}

 // Afficher les chaines de caractres
 Stream.Parse(Memo1.Lines);

 finally
  Stream.Free;
 end;
end;

end.
